Get Deployment Elasticsearch Resource Info
- Base URL
-
https://api.elastic-cloud.com/api/v1
- GET /deployments/{deployment_id}/elasticsearch/{ref_id}
Get info about an Elasticsearch Resource belonging to a given Deployment.
Query parameters
-
show_securityboolean · default: false -
Whether to include the Elasticsearch 2.x security information in the response - can be large per cluster and also include credentials.
-
show_metadataboolean · default: false -
Whether to include the full cluster metadata in the response - can be large per cluster and also include credentials.
-
show_plansboolean · default: true -
Whether to include the full current and pending plan information in the response - can be large per cluster.
-
show_plan_logsboolean · default: false -
Whether to include with the current and pending plan information the attempt log - can be very large per cluster.
-
show_plan_historyboolean · default: false -
Whether to include with the current and pending plan information the plan history- can be very large per cluster.
-
show_plan_defaultsboolean · default: false -
If showing plans, whether to show values that are left at their default value (less readable but more informative).
-
convert_legacy_plansboolean · default: false -
If showing plans, whether to leave pre-2.0.0 plans in their legacy format (the default), or whether to update them to 2.0.x+ format (if 'true').
-
show_system_alertsinteger · default: 0 -
Number of system alerts (such as forced restarts due to memory limits) to be included in the response - can be large per cluster. Negative numbers or 0 will not return field.
Responses
Standard response.
-
infoobjectrequired -
The information for an Elasticsearch cluster.
-
healthybooleanrequired -
Whether the cluster is healthy or not (one or more of the info subsections will have healthy: false)
-
statusrequired -
Cluster status
-
Values:
initializingstoppingstoppedrebootingrestartingreconfiguringstarted -
plan_infoobjectrequired -
Information about the current, pending, and past Elasticsearch cluster plans.
-
healthybooleanrequired -
Whether the plan situation is healthy (if unhealthy, means the last plan attempt failed)
-
currentobject -
Information about the Elasticsearch cluster plan.
-
plan_attempt_namestring -
A human readable name for each plan attempt, only populated when retrieving plan histories
-
healthybooleanrequired -
Either the plan ended successfully, or is not yet completed (and no errors have occurred)
-
attempt_start_timestring · format: date-time -
When this plan attempt (ie to apply the plan to the cluster) started (ISO format in UTC)
-
attempt_end_timestring · format: date-time -
If this plan completed or failed (ie is not pending), when the attempt ended (ISO format in UTC)
-
plan_end_timestring · format: date-time -
If this plan is not current or pending, when the plan was no longer active (ISO format in UTC)
-
planobject -
The plan for the Elasticsearch cluster.
-
cluster_topologyobjectrequired -
node_typeobject -
Controls the combinations of Elasticsearch node types. TIP: By default, the Elasticsearch node is master eligible, can hold data, and run ingest pipelines. WARNING: Do not set for tiebreaker topologies.
-
node_roles -
The list of node roles for this topology element (ES version >= 7.10). Allowable values are: master, ingest, ml, data_hot, data_content, data_warm, data_cold, data_frozen, remote_cluster_client, transform
-
Values:
masteringestmldata_hotdata_contentdata_warmdata_colddata_frozenremote_cluster_clienttransform -
elasticsearchobject -
The Elasticsearch cluster settings. When specified at the top level, provides a field-by-field default. When specified at the topology level, provides the override settings.
-
versionstring -
The version of the Elasticsearch cluster (must be one of the ECE supported versions). Currently cannot be different across the topology (and is generally specified in the globals). Defaults to the latest version if not specified.
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsobject -
A subset of Elasticsearch settings. TIP: To define the complete set of Elasticsearch settings, use
ElasticsearchSystemSettingswithuser_settings_override*anduser_settings*. -
scriptingobject -
Controls the languages supported by the Elasticsearch cluster, such as Painless, Mustache, and Expressions. Controls how the languages are used, such as file, index, and inline. TIP: For complex configurations, leave these blank and configure these settings in the user YAML or JSON.
-
painless_enabledboolean -
(5.x+ only) If enabled (the default) then the painless scripting engine is allowed as a sandboxed language. Sandboxed languages are the only ones allowed if 'sandbox_mode' is set to true. NOTES: (Corresponds to the parameters 'script.engine.painless.[file|stored|inline]')
-
mustache_enabledboolean -
(5.x+ only) If enabled (the default) then the mustache scripting engine is allowed as a sandboxed language. Sandboxed languages are the only ones allowed if 'sandbox_mode' is set to true. NOTES: (Corresponds to the parameters 'script.engine.mustache.[file|stored|inline]')
-
expressions_enabledboolean -
(5.x+ only) If enabled (the default) then the expressions scripting engine is allowed as a sandboxed language. Sandboxed languages are the only ones allowed if 'sandbox_mode' is set to true. NOTES: (Corresponds to the parameters 'script.engine.expression.[file|stored|inline]')
-
storedobject -
Enables scripting for the specified type and controls other parameters. Store scripts in indexes (
stored), upload in file bundles (file), or use in API requests (inline). -
enabledboolean -
If enabled (default: true) then scripts are enabled, either for sandboxing languages (by default), or for all installed languages if 'sandbox_mode' is disabled (or for 6.x). NOTES: (Corresponds to the parameter 'script.file|stored/indexed|inline')
-
sandbox_modeboolean -
If enabled (default: true) and this script type is enabled, then only the sandbox languages are allowed. By default the sandbox languages are painless, expressions and mustache, but this can be restricted via the 'painless_enabled', 'mustache_enabled' 'expression_enabled' settings.NOTES: Not supported in 6.x. (Corresponds to the parameters 'script.engine.[painless|mustache|expressions].[file|stored|inline]')
-
fileobject -
Enables scripting for the specified type and controls other parameters. Store scripts in indexes (
stored), upload in file bundles (file), or use in API requests (inline). -
enabledboolean -
If enabled (default: true) then scripts are enabled, either for sandboxing languages (by default), or for all installed languages if 'sandbox_mode' is disabled (or for 6.x). NOTES: (Corresponds to the parameter 'script.file|stored/indexed|inline')
-
sandbox_modeboolean -
If enabled (default: true) and this script type is enabled, then only the sandbox languages are allowed. By default the sandbox languages are painless, expressions and mustache, but this can be restricted via the 'painless_enabled', 'mustache_enabled' 'expression_enabled' settings.NOTES: Not supported in 6.x. (Corresponds to the parameters 'script.engine.[painless|mustache|expressions].[file|stored|inline]')
-
inlineobject -
Enables scripting for the specified type and controls other parameters. Store scripts in indexes (
stored), upload in file bundles (file), or use in API requests (inline). -
enabledboolean -
If enabled (default: true) then scripts are enabled, either for sandboxing languages (by default), or for all installed languages if 'sandbox_mode' is disabled (or for 6.x). NOTES: (Corresponds to the parameter 'script.file|stored/indexed|inline')
-
sandbox_modeboolean -
If enabled (default: true) and this script type is enabled, then only the sandbox languages are allowed. By default the sandbox languages are painless, expressions and mustache, but this can be restricted via the 'painless_enabled', 'mustache_enabled' 'expression_enabled' settings.NOTES: Not supported in 6.x. (Corresponds to the parameters 'script.engine.[painless|mustache|expressions].[file|stored|inline]')
-
reindex_whiteliststring -
Limits remote Elasticsearch clusters that can be used as the source for '_reindex' API commands
-
auto_create_indexboolean -
If true (the default), then any write operation on an index that does not currently exist will create it. NOTES: (Corresponds to the parameter 'action.auto_create_index')
-
enable_close_indexboolean -
Defaults to false on versions <= 7.2.0, true otherwise. If false, then the API commands to close indices are disabled. This is important because Elasticsearch does not snapshot or migrate close indices on versions under 7.2.0, therefore standard Elastic Cloud configuration operations will cause irretrievable loss of indices' data. NOTES: (Corresponds to the parameter 'cluster.indices.close.enable')
-
destructive_requires_nameboolean -
If true (default is false) then the index deletion API will not support wildcards or '_all'. NOTES: (Corresponds to the parameter 'action.destructive_requires_name')
-
watcher_trigger_enginestring -
The trigger engine for Watcher, defaults to 'scheduler' - see the xpack documentation for more information. NOTES: (Corresponds to the parameter '(xpack.)watcher.trigger.schedule.engine', depending on version. Ignored from 6.x onwards.)
-
default_shards_per_indexinteger · format: int32 -
(2.x only - to get the same result in 5.x template mappings must be used) Sets the default number of shards per index, defaulting to 1 if not specified. (Corresponds to the parameter 'index.number_of_shards' in 2.x, not supported in 5.x)
-
user_settings_jsonobject -
An arbitrary JSON object allowing cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters arey are on the allowlist and not on the denylist. NOTES: (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Elasticsearch settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters arey are on the allowlist and not on the denylist. NOTES: (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Elasticsearch settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. NOTES: (This field together with 'system_settings' and 'user_settings*' defines the total set of Elasticsearch settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. NOTES: (This field together with 'system_settings' and 'user_settings*' defines the total set of Elasticsearch settings)
-
enabled_built_in_pluginsstring -
A list of plugin names from the Elastic-supported subset that are bundled with the version images. NOTES: (Users should consult the Elastic stack objects to see what plugins are available, this is currently only available from the UI)
-
user_bundlesobject -
A list of admin-uploaded bundle objects (eg scripts, synonym files) that are available for this user.
-
instance_configuration_idstring -
Controls the allocation of this topology element as well as allowed sizes and node_types. It needs to match the id of an existing instance configuration.
-
instance_configuration_versioninteger · format: int32 -
The version of the Instance Configuration Id. If it is unset, the meaning depends on read vs writes. For deployment reads, it is equivalent to version 0 (or the IC is unversioned); for deployment creates and deployment template use, it is equivalent to 'the latest version'; and for deployment updates, it is equivalent to 'retain the current version'.
-
sizeobject -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
autoscaling_minobject -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
autoscaling_maxobject -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
autoscaling_policy_override_jsonobject -
An arbitrary JSON object overriding the default autoscaling policy. Don't set unless you really know what you are doing.
-
topology_element_controlobject -
Controls for the topology element. Only used as part of the deployment template. Ignored if included as part of a deployment.
-
autoscaling_tier_overrideboolean -
Set to true to enable autoscaling for this topology element, even if the cluster-level 'autoscaling_enabled' field is false. Note that 'autoscaling_tier_override' cannot be set to false if cluster-level 'autoscaling_enabled' is true. Currently only supported for the 'ml' tier
-
elasticsearchobjectrequired -
The Elasticsearch cluster settings. When specified at the top level, provides a field-by-field default. When specified at the topology level, provides the override settings.
-
transientobject -
Defines the configuration parameters that control how the plan is applied. For example, the Elasticsearch cluster topology and Elasticsearch settings.
-
strategyobject -
The options for performing a plan change. Specify only one property each time. The default is
grow_and_shrink. -
rollingobject -
Performs inline, rolling configuration changes that mutate existing containers. TIP: This is the fastest way to update a plan, but can fail for complex plan changes, such as topology changes. Also, this is less safe for configuration changes that leave a cluster in a non running state. NOTE: When you perform a major version upgrade, and 'group_by' is set to 'pass:macros[all]';, rolling is required.
-
group_bystring -
Specifies the grouping attribute to use when rolling several instances. Instances that share the same value for the provided attribute key are rolled together as a unit. Examples that make sense to use are '__all__' (roll all instances as a single unit), 'logical_zone_name' (roll instances by zone), '__name__' (roll one instance at a time, the default if not specified). Note that '__all__' is required when performing a major version upgrade
-
allow_inline_resizeboolean -
Whether we allow changing the capacity of instances (default false). This is currently implemented by stopping, re-creating then starting the affected instance on its associated allocator when performing the changes. NOTES: This requires a round-trip through the allocation infrastructure of the active constructor, as it has to reserve the target capacity without over-committing
-
grow_and_shrinkobject -
A strategy that creates instances with the new plan, migrates data from the old instances, then shuts down the old instances.
GrowShrinkStrategyConfigis safer than 'rolling' and ensures single node availability during a plan change, but can be a lot slower on larger clusters. -
plan_configurationobject -
The configuration settings for the timeout and fallback parameters.
-
timeoutinteger · format: int64 -
The total timeout in seconds after which the plan is cancelled even if it is not complete. Defaults to 4x the max memory capacity per node (in MB). NOTES: A 3 zone cluster with 2 nodes of 2048 each would have a timeout of 4*2048=8192 seconds. Timeout does not include time required to run rollback actions.
-
calm_wait_timeinteger · format: int64 -
This timeout determines how long to give a cluster after it responds to API calls before performing actual operations on it. It defaults to 5s
-
skip_snapshotboolean -
If true (default: false), does not take (or require) a successful snapshot to be taken before performing any potentially destructive changes to this cluster
-
max_snapshot_attemptsinteger · format: int32 -
If taking a snapshot (ie unless 'skip_snapshots': true) then will retry on failure at most this number of times (default: 5)
-
max_snapshot_ageinteger · format: int64 -
When you take a snapshot and 'skip_snapshots' is false, specifies the maximum age in seconds of the most recent snapshot before a new snapshot is created. Default is 300
-
extended_maintenanceboolean -
If true (default false), does not clear the maintenance flag (which prevents its API from being accessed except by the constructor) on new instances added until after a snapshot has been restored, otherwise, the maintenance flag is cleared once the new instances successfully join the new cluster
-
restore_snapshotobject -
Restores a snapshot from a local or remote repository.
-
repository_namestring -
If specified, contains the name of the snapshot repository - else will default to the Elastic Cloud system repo ('found-snapshots')
-
snapshot_namestringrequired -
The name of the snapshot to restore. Use '__latest_success__' to get the most recent snapshot from the specified repository
-
repository_configobject -
Configures the location of a remote repository. The default is the system repository.
-
restore_payloadobject -
The configuration for the restore command, such as which indices you want to restore.
-
snapshot_dependencyobject -
Configuration for attaching a snapshot repository dependency from another cluster. This creates a snapshot repository in the target cluster pointing to the source cluster's snapshots.
-
remote_clustersobject -
The list of resources used as remote clusters
-
resourcesobjectrequired -
The remote resources
-
elasticsearch_ref_idstringrequired -
The locally-unique user-specified id of an Elasticsearch Resource
-
aliasstringrequired -
The alias for this remote cluster. Aliases must only contain letters, digits, dashes and underscores
-
If true, skip this cluster during search if it is disconnected. Default: false
-
cluster_settings_jsonobject -
If specified, contains transient settings to be applied to an Elasticsearch cluster during changes,default values shown below applied. These can be overridden by specifying them in the map (or null to unset). Additional settings can also be set. Settings will be cleared after the plan has finished. If not specified, no settings will be applied. NOTE: These settings are only explicitly cleared for 5.x+ clusters, they must be hand-reset to their defaults in 2.x- (or a cluster reboot will clear them).
- indices.store.throttle.max_bytes_per_sec: 120Mb
- indices.recovery.max_bytes_per_sec: 120Mb
- cluster.routing.allocation.cluster_concurrent_rebalance: 5
- cluster.routing.allocation.node_initial_primaries_recoveries: 5
- cluster.routing.allocation.node_concurrent_incoming_recoveries: 5 For version 8.1 and later no defaults are provided through this mechanism, but instead hardware dependent settings are provided to each instance.
-
plan_attempt_logobjectrequired -
elasticsearchobjectrequired -
Information about the Elasticsearch cluster.
-
healthybooleanrequired -
Whether the Elasticsearch cluster is healthy (check the sub-objects for more details if not)
-
shard_infoobjectrequired -
Warning
This endpoint is deprecated and scheduled to be removed in the next major version. Use
shards_statusinstead.Information about the shards and replicas that comprise the Elasticsearch indices.
-
shards_statusobject -
Shards status represented as green, yellow, or red, as returned by the Elasticsearch cluster health API
-
master_infoobjectrequired -
Information about the master nodes in the Elasticsearch cluster.
-
blocking_issuesobjectrequired -
Warning
This endpoint is deprecated and scheduled to be removed in the next major version. Use
cluster_blocking_issuesinsteadIssues that prevent the Elasticsearch cluster or index from operating correctly.
-
metadataobjectrequired -
Information about the public and internal state, and the configuration settings of an Elasticsearch cluster.
-
last_modifiedstring · format: date-timerequired -
The most recent time the cluster metadata was changed (ISO format in UTC)
-
aliased_endpointstring -
The DNS name of the cluster endpoint derived from the deployment alias, if available
-
cloud_idstring -
The cloud ID, an encoded string that provides other Elastic services with the necessary information to connect to this Elasticsearch and Kibana (only present if both exist)
-
rawobject -
An unstructured JSON representation of the public and internal state (can be filtered out via URL parameter). The contents and structure of the
rawfield can change at any time. -
portsobject -
Information about the ports that allow communication between the Elasticsearch cluster and various protocols.
-
topologyobjectrequired -
The topology for Elasticsearch clusters, multiple Kibana instances, or multiple APM Servers. The
ClusterTopologyInfoalso includes the instances and containers, and where they are located. -
healthybooleanrequired -
Whether the cluster topology is healthy (ie all instances are started and the services they run - ie elasticsearch - are available
-
instancesobjectrequired -
instance_configurationobject -
Information about a configuration that creates a Kibana instance or APM Server.
-
config_versioninteger · format: int32 -
If the IC is configuration controlled, this field is the version either being read back (reads return the latest IC unless specified by the 'config_version' URL param), or the version to update. Cannot be used in creates. For unversioned IC reads it is left empty.
-
service_versionstring -
The version of the service that the instance is running (eg Elasticsearch or Kibana), if available
-
container_startedbooleanrequired -
Whether the container has started (does not tell you anything about the service -ie Elasticsearch- running inside the container)
-
service_runningbooleanrequired -
Whether the service launched inside the container -ie Elasticsearch- is actually running
-
maintenance_modebooleanrequired -
Whether the service is is maintenance mode (meaning that the proxy is not routing external traffic to it)
-
allocator_idstring -
The id of the allocator on which this instance is running (if the container is started or starting)
-
memoryobject -
Information about the specific instances memory capacity and its usage
-
service_rolesstring -
List of roles assigned to the service running in the instance. Currently only populated for Elasticsearch, with possible values: master,data,ingest,ml
-
securityobject -
For 2.x Elasticsearch clusters, specifies the information about the users and roles. For 5.x Elasticsearch clusters, use the Kibana management UI.
-
elasticsearch_monitoring_infoobject -
Information about the monitoring status for the Elasticsearch cluster.
-
snapshotsobjectrequired -
Information about the snapshot status for the Elasticsearch cluster. For example, the health status.
-
linksmap string to object -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
settingsobject -
The settings for an Elasticsearch cluster.
-
dedicated_masters_thresholdinteger · format: int32 -
Threshold starting from which the number of instances in the cluster results in the introduction of dedicated masters. If the cluster is downscaled to a number of nodes below this one, dedicated masters will be removed. Limit is inclusive. When provided the threshold setting is updated. A
nullvalue removes the field. Otherwise, the setting remains as it was set previously. -
trustobject -
Configuration of trust with other clusters.
-
directobject -
The list of trust relationships where the certificate is bundled with the trust setting. Allows configuring trust for clusters running outside of an Elastic Cloud managed environment or in an Elastic Cloud environment without an environment level trust established.
-
uidstring -
Auto generated identifier for this trust, allows distinguishing between update vs remove and add.
-
type -
The type can either be ESS, ECE, generic or proxy. If none is specified, then generic is assumed. If proxy is specified, trust_all should be false and trust_allowlist, scope_id and additional_node_names should be omitted.
-
Values:
ECEESSgenericproxy -
trust_allbooleanrequired -
If true, scope_id is required and the
trust_allowlistis ignored and all clusters matching the scope id will be trusted. -
trust_allowliststring -
The list of clusters with matching scope to trust. Only used when
trust_allis false. Providing one or more clusters makes scope_id mandatory. -
scope_idstring -
A lowercase alphanumerical string of max 32 characters. Usually an organization id or an environment id, but could really be any suitable suffix for clusters using the CA certificate of this trust. Required unless trust_all is false and trust_allowlist is empty.
-
additional_node_namesstring -
A list of node names trusted in addition to those deducible from trust_allowlist and scope id. Allows trusting nodes that don't have a scoped name at the cost of maintaining the list. Mandatory if scope id is not defined. Wildcards are not allowed.
-
keystore_contentsobject -
The contents of the Elasticsearch keystore.
-
secretsmap string to objectrequired -
List of secrets
-
<string>object -
valueobject -
Value of this setting. This can either be a string or a JSON object that is stored as a JSON string in the keystore. NOTE: When the keystore secret is unspecified, it is removed.
-
as_fileboolean -
Stores the keystore secret as a file. The default is false, which stores the keystore secret as string when value is a plain string, or true when value is an object.
The Deployment specified by {deployment_id} cannot be found. (code: deployments.deployment_not_found)
We have failed you. (code: deployments.deployment_resource_no_longer_exists)